<?php
/*
Plugin Name: Sale Offer Ads Plugin
Plugin URI: http://www.wordpressdirect.com
Description: Widget that shows Ads provided by WordPressDirect.com
Author: WPD Team
Version: 1.1
Author URI: http://www.wordpressdirect.com
*/

// Displays widget on blag
// $widget_args: number
//    number: which of the several widgets of this type do we mean

function wpd_ads_init() {

    // Check to see required Widget API functions are defined...
    if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
        return; // ...and if not, exit gracefully from the script.

    // This function prints the sidebar widget--the cool stuff!
    function widget_wpd_ads($args) {

        // $args is an array of strings which help your widget
        // conform to the active theme: before_widget, before_title,
        // after_widget, and after_title are the array keys.
        extract($args);

        // Collect our widget's options, or define their defaults.
        $options = get_option('widget_wpd_ads');
        $title = empty($options['title']) ? 'Sale Offer' : $options['title'];
	if (empty($options['content'])) return;
        $text = empty($options['text']) ? 'Sale Offer Ads Content!' : $options['content'];

         // It's important to use the $before_widget, $before_title,
         // $after_title and $after_widget variables in your output.
	echo $before_widget;
	echo $before_title;
	echo $title;	
	echo $after_title;

	echo '<div class="textwidget">';
	echo $options['content'];
	echo '</div>';

	echo $after_widget;
    }

    // This is the function that outputs the form to let users edit
    // the widget's title and so on. It's an optional feature, but
    // we'll use it because we can!
    function widget_wpd_ads_control() {

        // Collect our widget's options.
        $options = get_option('widget_wpd_ads');

        // This is for handing the control form submission.
        if ( $_POST['mywidget-submit']=='1' ) {
            // Clean up control form submission options
            $options['title'] = stripslashes($_POST['mywidget-title']);
            $options['content'] = stripslashes($_POST['mywidget-content']);
	   update_option('widget_wpd_ads', $options);
        }
        // Format options as valid HTML. Hey, why not.
        $title = htmlspecialchars($options['title'], ENT_QUOTES);
        $content = htmlspecialchars($options['content'], ENT_QUOTES);

// The HTML below is the control form for editing options.
?>
        <div>
        <label for="mywidget-title" style="line-height:35px;display:block;">Sale Offer Title: <input class="widefat" type="text" id="mywidget-title" name="mywidget-title" value="<?php echo $title; ?>" /></label>
        <label for="mywidget-text" style="line-height:35px;display:block;">Sale Offer Content: </label><br>
	<textarea class="widefat" rows="16" cols="20" type="text" id="mywidget-content" name="mywidget-content"><?php echo $content; ?></textarea>
        <input type="hidden" name="mywidget-submit" id="mywidget-submit" value="1" />
        </div>
    <?php
    // end of widget_mywidget_control()
    }

    // This registers the widget. About time.
    register_sidebar_widget('Sale Offer Ads', 'widget_wpd_ads');

    // This registers the (optional!) widget control form.
    register_widget_control('Sale Offer Ads', 'widget_wpd_ads_control');
}

// Delays plugin execution until Dynamic Sidebar has loaded first.
add_action('plugins_loaded', 'wpd_ads_init');

?>